package teikade.debug;

import java.io.*;
import teikade.net.*;

public class ResetBreakPoint extends Packet implements DebuggerManagerPacket {
    String className;
    int lineNumber;

    public ResetBreakPoint() {
    }

    public ResetBreakPoint(String className, int lineNumber) {
	this.className  = className;
	this.lineNumber = lineNumber;
    }

    public void init() throws IllegalArgumentException {
	className = getStringArgument();
	lineNumber = getIntArgument();
    }

    public void execute(Object target) {
	((DebuggerManager)target).breakPointNotify(this, false);
    }

    public String argumentsToString() {
	return toStreamString(className) + ", " + lineNumber;
    }

    public int getLineNumber() {
	return lineNumber;
    }

    public String getClassName() {
	return className;
    }
}
