/*
 * Copyright (c) 1995-1998 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.gui.menu;

import teikade.sys.*;
import teikade.gui.*;
import teikade.gui.component.*;
import teikade.util.Compile;
import java.io.File;

public class CompileMenuBar extends CommandMenuBar {

    protected static final String MENU_RECOMPILE = "recompile";

    protected boolean createFileCommandMenu(DMenu menu) {
	//super.createFileCommandMenu(menu);
	menu.add(MENU_STOP);
        menu.add(MENU_RECOMPILE);
	return true;
    }

    protected void actionFileMenu(String label, TeikadeFrame frame, CodePath cp) {
	if (label.equals(MENU_RECOMPILE)) {
	    if (!frame.acceptWithConfirm()) {
		frame.information("Compilation on " + cp.printString() + " aborted.");
	    } else {
		((CompileFrame)frame).restart();
	    }
        } else {
	    super.actionFileMenu(label, frame, cp);
	}
    }

    protected void actionClassMenu(String label, TeikadeFrame frame, CodePath cp) {
	if (cp.classManager() == null) cp = ((CompileFrame)frame).getExecuteCodePath();
	super.actionClassMenu(label, frame, cp);
    }

    public void updateExecuteMenuActivity(CodePath cp) {
	DMenu menu = classMenu;
	ClassManager cm = cp.classManager();
	if (cm != null) {
	    TeikadeFile sourceFile = TeikadeFile.create(cp.sourceFileManager().absolutePath());
	    String cf = sourceFile.getParent() + File.separator + cm.name() + ".class";
	    TeikadeFile classFile = TeikadeFile.create(cf);
	    if (!classFile.exists()) return;
	    if (sourceFile.lastModified() > classFile.lastModified()) return;
	    if (Compile.canExecute(cp)) {
		menu.enable(MENU_COMPILE);
	    }
	    if (ClassManager.canExecute()) {
		if (cm.hasMainMethod()) {
		    menu.enable(MENU_EXECUTE);
		    menu.enable(MENU_EXECUTE_WITH_ARGS);
		}
		if (cm.isApplet()) {
		    menu.enable(MENU_EXECUTE);
		    menu.enable(MENU_EXECUTE_WITH_ARGS);
		    menu.enable(MENU_EXECUTE_WITH_HTML);
		}
	    }
	}
    }
}
