/*
 * Copyright (c) 1997 PFU Limited.
 *	author Kazuhisa Shirakami
 */
package teikade.util;

import java.io.*;
import teikade.sys.TeikadeFile;

public class CodeConverter1_1 implements CodeConverterPeer {

    public String toString(byte bytes[], int offset, int count) {
	return new String(bytes, offset, count);
    }

    public String toString(TeikadeFile file)
    throws FileNotFoundException, IOException {
	InputStream is = file.getInputStream();
	try {
	    char[] chars = new char[is.available()];
	    InputStreamReader reader =
		new InputStreamReader(new BufferedInputStream(is));
	    int len = reader.read(chars, 0, chars.length);
	    return new String(chars, 0, len);
	} catch (CharConversionException e) {
	} finally {
	    is.close();
	}
	is = file.getInputStream();
	try {
	    byte[] bytes = new byte[is.available()];
	    is.read(bytes);
	    return new String(bytes, 0);
	} finally {
	    is.close();
	}
    }

    public String readLine(DataInputStream dis) throws IOException {
	String string = dis.readLine();
	if (string == null) return null;
	byte[] bytes = new byte[string.length()];
	for (int i = 0; i < bytes.length; i++) {
	    bytes[i] = (byte)string.charAt(i);
	}
	return toString(bytes, 0, bytes.length);
    }

    public byte toBytes(String string)[] {
	return string.getBytes();
    }
}
