/*
 * Copyright (c) 1998 PFU Limited.
 *      author Kazuhisa Shirakami
 */
package teikade.util;

import teikade.sys.CodePath;

public class CompileJDKNoWindow extends CompileJDK {
    private static final String JAVAC = "sun.tools.javac.Main";

    public static boolean canExecute() {
	return getJDKNoWindowCommandName() != null;
    }

    public static String getJDKNoWindowCommandName() {
	try {
	    Class.forName(JAVAC);
	    return CommandExternal.getJDKCommandName("javaw");
	} catch (Exception e) {
	    return null;
	}
    }

    public String getJDKNoWindowCommandOptions() {
	StringBuffer options = new StringBuffer();
	options.append(JAVAC).append(' ');
	addJDKCommandOptions(options);
	return options.toString();
    }

    public CompileJDKNoWindow() {
    }

    public String getDefaultCommandName() {
	return getJDKNoWindowCommandName();
    }

    public String getDefaultCommandOptions() {
	return getJDKNoWindowCommandOptions();
    }
}
