/*
 * Copyright (c) 1999 PFU Limited.
 *      author Kazuhisa Shirakami
 */
package teikade.util;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import teikade.sys.TeikadeProperties;

public class CompileProperties {
    private boolean editable = true;
    private Vector names = new Vector();
    private Hashtable labels = new Hashtable();

    public void add(String name, String label, String value) {
	names.addElement(name);
	labels.put(name, label);
	if (value != null) {
	    TeikadeProperties.setDefault(name, value);
	}
    }

    public void setEditable(boolean editable) {
	this.editable = editable;
    }

    public boolean isEditable() {
	return editable;
    }

    public Enumeration getNames() {
	return names.elements();
    }

    public String getLabel(String name) {
	return (String)labels.get(name);
    }

    public String getDefaultString(String name) {
	return TeikadeProperties.getDefault(name);
    }

    public String getString(String name) {
	return TeikadeProperties.getString(name);
    }

    public String getParsedString(String name) {
	return TeikadeProperties.getParsedString(name);
    }

    public void put(String name, String value) {
	TeikadeProperties.putWithoutNotify(name, value);
    }
}
