/*
 * Copyright (c) 1998 SCK Files, PFU Limited.
 * author Maurizio Scaglione.
 *
 */
package teikade.util;

import teikade.sys.*;

public class GrepInternalJava extends GrepInternalExpression {

    protected void grep(byte[] text, SourceFileManager src) {
	int status = 0x00;
    	int bol = 0, eol = 0, line = 1;
	for (int i = 0; i < text.length; i++) {
	    switch (text[i]) {
	    case '\r':		       // CR
		if (status == 0x00) eol = i;
		else if (status == 0x01) status = 0x00;
		if (i + 1 < text.length && text[i + 1] == '\n') {
		    ++i;               // CR+LF
		}
		break;
	    case '\n':                 // LF
		if (status == 0x00) eol = i;
		else if (status == 0x01) status = 0x00;
		break;
	    case '/':                  
		if (i + 1 < text.length) {
		    if (text[i + 1] == '/') {
			status = 0x01;     // C++ comment
			eol = i;
		    } else if (text[i + 1] == '*') {
			status = 0x02;     // C comment
			eol = i;
		    } else if (i > 0 && text[i - 1] == '*') {
			status = 0x00;     // C comment end
			bol = i + 2;
		    }
		}
		continue;
	    default:
		continue;
	    }
	    if (eol > bol) { // check line
		int index = -1;
		if ((index = head.grep(text, bol, eol)) != -1) {
		    try {
			String lineString = CodeConverter.toString(text, bol, eol - bol);
			int offset = lineString.indexOf(trimmedPattern, index - bol);
			String detail = src.path() + ":" + line + ":" + lineString;
			CodeLocation result = new CodeLocation(
			     src.absolutePath(), line, detail,
			     offset, patternLength);
			addResult(result);
		    } catch (CodeLocationException e) {
			 addMessage("fail toIndex search location "
			 + src.absolutePath() + ":" + line + ", sorry.\n");
		    }
		}
	    }
	    ++line;
	    bol = i + 1;
	}
    }
}
